﻿using NAudio.CoreAudioApi;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace AudioLevelDisp
{
    public partial class AudioLevelMeter : UserControl
    {

        private MMDeviceEnumerator mMDeviceEnum;
        private MMDeviceCollection mMDevices;
        private MMDevice mMDevice;
        private Timer tm1;
        
        
        public AudioLevelMeter()
        {
            InitializeComponent();

            mMDeviceEnum = new MMDeviceEnumerator();
            mMDevices = mMDeviceEnum.EnumerateAudioEndPoints(DataFlow.Render, DeviceState.Active);

            mMDevComboBox1.Items.AddRange(mMDevices.ToArray());

            tm1 = new Timer();
            tm1.Interval = 100;
            tm1.Tick += Tm1_Tick;



        }


        private void Tm1_Tick(object sender, EventArgs e)
        {
            if (mMDevice == null) return;

            colorProgressBars[0].Value = (int)Math.Round(mMDevice.AudioMeterInformation.MasterPeakValue * 100);

            for (int i = 0; i < mMDevice.AudioMeterInformation.PeakValues.Count; i++)
            {
                int iPeakValue = (int)Math.Round(mMDevice.AudioMeterInformation.PeakValues[i] * 100);
                colorProgressBars[i+1].Value = iPeakValue;
                this.Invalidate();
            }
        }

        List<ColorProgressBar> colorProgressBars = new List<ColorProgressBar>();


        private void mMDevComboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (mMDevComboBox1.SelectedItem != null)
            {
                tm1.Stop();

                int iHeight = 0;
                mMDevice = (MMDevice)mMDevComboBox1.SelectedItem;

                if (colorProgressBars != null)
                {
                    colorProgressBars.Clear();

                }
                mainFlowLayoutPanel1.Controls.Clear();

                int iAddCnt = 0;
                ColorProgressBar cPb1 = new ColorProgressBar()
                {
                    Minimum = 0,
                    Maximum = 100,
                    Width = mainFlowLayoutPanel1.ClientSize.Width,

                    ForeColor = Color.YellowGreen,
                    BackColor = Color.White,
                    Name = "VOL",
                    Dock = DockStyle.Top,
                    Anchor = AnchorStyles.Top | AnchorStyles.Left | AnchorStyles.Right,
                    Height = 20
                };

                colorProgressBars.Add(cPb1);
                iAddCnt += 1;
                iHeight += cPb1.Height;
                mainFlowLayoutPanel1.Controls.Add(cPb1);


                mMDevice = mMDevices[mMDevComboBox1.SelectedIndex];
                int iCnt = mMDevice.AudioMeterInformation.PeakValues.Count;

                for (int i = 0; i < iCnt; i++)
                {

                    ColorProgressBar cPb2 = new ColorProgressBar()
                    {
                        Minimum = 0,
                        Maximum = 100,
                        Width = mainFlowLayoutPanel1.ClientSize.Width,
                        ForeColor = Color.Yellow,
                        BackColor = Color.Black,
                        Name = "CH" + iAddCnt.ToString(),
                        Dock = DockStyle.Top,
                        Anchor = AnchorStyles.Top|AnchorStyles.Left|AnchorStyles.Right,
                        Height = 20,

                    };
                    colorProgressBars.Add(cPb2);
                    mainFlowLayoutPanel1.Controls.Add(cPb2);
                    iHeight += cPb2.Height;
                    iAddCnt += 1;
                }

                mainFlowLayoutPanel1.Height = iHeight + (mainFlowLayoutPanel1.Controls.Count*6);

                tm1.Start();



            }
        }

        private void AudioLevelMeter_Load(object sender, EventArgs e)
        {
            var mm = mMDeviceEnum.GetDefaultAudioEndpoint(DataFlow.Render, Role.Multimedia);
            for (int i = 0; i < mMDevices.Count; i++)
            {
                if (mm.FriendlyName == mMDevices[i].FriendlyName)
                {
                    mMDevComboBox1.SelectedIndex = i;
                }
            }
        }

        private void AudioLevelMeter_Resize(object sender, EventArgs e)
        {
            foreach (ColorProgressBar cpb in colorProgressBars)
            {
                cpb.Width = mainFlowLayoutPanel1.ClientSize.Width;
            }
        }
    }


}
