﻿using NAudio.CoreAudioApi;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace AudioLevelDisp
{
    public partial class Form1 : Form
    {

        public Form1()
        {
            InitializeComponent();
            timer1.Start();
        }

        private AudioLevelMeter alm;
        private void Form1_Load(object sender, EventArgs e)
        {
            alm = new AudioLevelMeter();
            alm.Width = this.ClientSize.Width;
            alm.Anchor = AnchorStyles.Top | AnchorStyles.Left | AnchorStyles.Right;
            this.Controls.Add(alm);

            this.Height = alm.Height;
        }


    }

    public class ColorProgressBar : ProgressBar
    {
        public ColorProgressBar()
        {
            //Paintイベントが発生するようにする
            //ダブルバッファリングを有効にする
            base.SetStyle(ControlStyles.UserPaint |
                ControlStyles.AllPaintingInWmPaint |
                ControlStyles.OptimizedDoubleBuffer, true);
        }

        //protected override void OnPaint(PaintEventArgs e)
        //{
        //    Brush backBrush = new SolidBrush(this.BackColor);
        //    Brush foreBrush = new SolidBrush(this.ForeColor);

        //    //背景を描画する
        //    e.Graphics.FillRectangle(backBrush, this.ClientRectangle);

        //    //バーの幅を計算する
        //    int chunksWidth = (int)(
        //        (double)this.ClientSize.Width *
        //        (double)(this.Value - this.Minimum) /
        //        (double)(this.Maximum - this.Minimum));

        //    Rectangle chunksRect = new Rectangle(0, 0, chunksWidth, this.ClientSize.Height);
        //    //バーを描画する
        //    e.Graphics.FillRectangle(foreBrush, chunksRect);

        //    backBrush.Dispose();
        //    foreBrush.Dispose();
        //}

        protected override void OnPaint(PaintEventArgs e)
        {
            Brush backBrush = new SolidBrush(this.BackColor);
            Brush foreBrush = new SolidBrush(this.ForeColor);

            //背景を描画する
            //ProgressBarRenderer.DrawHorizontalBar(e.Graphics, this.ClientRectangle);
            e.Graphics.FillRectangle(backBrush, this.ClientRectangle);

            //バーの幅を計算する
            //上下左右1ピクセルの枠の部分を除外して計算する
            double percent = (double)(this.Value - this.Minimum)
                / (double)(this.Maximum - this.Minimum);
            int chunksWidth = (int)((double)(this.ClientSize.Width - 2) * percent);

            Rectangle chunksRect = new Rectangle(1, 1, chunksWidth, this.ClientSize.Height - 2);
            //バーを描画する
            //ProgressBarRenderer.DrawHorizontalChunks(e.Graphics, chunksRect);
            e.Graphics.FillRectangle(foreBrush, chunksRect);

            //表示する文字列を決定する
            string displayText2 = string.Format(Name + ":{0}/{1}", this.Value, this.Maximum);

            //文字列を描画する
            TextFormatFlags tff = TextFormatFlags.Left |
                TextFormatFlags.VerticalCenter |
                TextFormatFlags.SingleLine;
            TextRenderer.DrawText(e.Graphics, displayText2, this.Font,
                this.ClientRectangle, SystemColors.ControlText, tff);

            backBrush.Dispose();
            foreBrush.Dispose();
        }

    }
}
